/********************************************************************************************************
		* PROGRAM      : menus
		* DATE - TIME  : jeudi 26 avril 2007 - 10h39
		* AUTHOR       : gilles bailly ( gilles.bailly@enst.fr )
			* FILENAME     : Flower16_3Menu.h
			* LICENSE      : GPL
			* COMMENTARY   :
********************************************************************************************************/
//FlowerGroupingMenu.h

#ifndef __FLOWERGrouping_MENU__
#define __FLOWERGrouping_MENU__

#include "FlowerGroupingStateMachine.h"
#include "RadialMenu.h"


class FlowerGroupingSector;
class GMConfiguration;
class FlowerRecognizer;
//================================
class FlowerGroupingMenu : public RadialMenu{
Q_OBJECT
public:
friend class FlowerGroupingStateMachine;
friend class FlowerGroupingStateClosed;
friend class FlowerGroupingStateBegin;
friend class FlowerGroupingStateTracing;
friend class FlowerGroupingStateConfiguration;
friend class GMConfiguration;

static int getDirAndBranch(int id, int& _branch);

FlowerGroupingMenu(QWidget *parent =0);
virtual ~FlowerGroupingMenu();

virtual void addFlowerGroupingSector(FlowerGroupingSector* sector);
virtual void addSpecificSector(FlowerGroupingSector* sector, int _id );
virtual void initialize();
virtual void setModeKey(bool );
virtual void defineConfiguration(int* _dir, int* _branch, int _nb);

bool drawController;

protected:
virtual StateMachine* getCurrentState();
virtual void setDefaultState();
virtual int getNoviceGesture();
virtual int getExpertGesture();
virtual int getKey();
virtual void setKey( int );
virtual bool getModeKey();

//===============

int key;

bool modeKey;

int l0;
//===============
FlowerGroupingStateClosed* stateClosed;
FlowerGroupingStateBegin* stateBegin;
FlowerGroupingStateTracing* stateTracing;
FlowerGroupingStateConfiguration* stateConfiguration;
FlowerGroupingStateMachine* stateCurrent;


private:
std::vector<int> vItem;
GMConfiguration* configuration;
FlowerRecognizer* flowerRecognizer;


/*
5  4
		6      3

7			     2
		8						  1
		9            16
		10         15

11    14
		Grouping 13
*/
//=================


};

#endif
