/********************************************************************************************************
		* PROGRAM      : menus
		* DATE - TIME  : lundi 30 avril 2007 - 09h56
		* AUTHOR       : gilles bailly ( gilles.bailly enst.fr )
			* FILENAME     : FlowerGroupingSector.cpp
			* LICENSE      : GPL
			* COMMENTARY   :
********************************************************************************************************/

//FlowerGroupingSector.cpp

#include <sstream>
#include <iostream>
#include <fstream>
#include <string>
#include <math.h>
#include <stdlib.h>
#include <time.h>

#include <QPainter>
#include <QRectF>
#include <QColor>
#include <QEvent>
#include <QMouseEvent>
#include <QPoint>
#include <QPainterPath>
#include <QFile>
#include <QTextStream>

#include "FlowerGroupingSector.h"
#include "FlowerGroupingMenu.h"
#include "RadialMenu.h"

using namespace std;

//====================
bool FlowerGroupingSector::first = true;
int FlowerGroupingSector::l0 = 7;
int FlowerGroupingSector::rayon = 150;
vector<QPointF> FlowerGroupingSector::position;
vector<QPointF> FlowerGroupingSector::lineDepart;
vector<QPointF> FlowerGroupingSector::controler;
vector<QPointF> FlowerGroupingSector::lineFin;
//string FlowerGroupingSector::nameFile_ = "/conf/positionFile.txt";

	
#if defined(Q_OS_WIN)	
	QString FlowerGroupingSector::nameFile_ = ":conf/positionFileWIN.txt";
#elif defined(Q_OS_MAC)
  QString FlowerGroupingSector::nameFile_ = ":conf/positionFileMAC.txt";
#endif


//=================
FlowerGroupingSector::FlowerGroupingSector(const QString& text, QWidget* parent,
		Qt::WindowFlags _f): RadialSector(text, parent, _f){
			RadialMenu* m = qobject_cast<RadialMenu *> ( parent );
	if( !m ){ cerr<<"error radialMenu initialize"<<endl; }
	
	//m->setMenuFont( QFont("Helvetica", 14) );
	
	mainWidget->setFont( m->font()  );
	mainWidget->show(); // pour le redimensionnent de l'item
}

//=================
void FlowerGroupingSector::writePositionFile(){
/*
	std::string nameFile = RadialMenu::MENU_PATH + nameFile_;
	
	ofstream* out;
	out= new ofstream( nameFile.c_str() );
	
	QPointF center( 500, 500 );
	for(unsigned int i = 0;  i < 800 ; i++ ){
		
		//lineDepart[i ] = (position[ i ] + 3 * center ) /4;
		//lineFin[ i ] = ( 3 * position[ i ] + center ) / 4;
		//controler[ i ] = ( position[ i ] + center ) / 2;
		
		*out<< "item " << i << " \t " << position[ i ].x() <<" " << position[ i ].y();
		*out<<"\t"<< lineDepart[ i ].x() << " " << lineDepart[ i ].y();
		*out<< "\t"<< controler[ i ].x() << " "<< controler[ i ].y();
		*out<<"\t"<< lineFin[ i ].x() << " " << lineFin[ i ].y();
		*out<<endl; //item
		if( position[i].x() != 0 ){
		}
	}
	
	out->close();
	delete out; out= 0;
	*/
}

//=================
void FlowerGroupingSector::loadPositionFile(){
  QFile file( nameFile_ );
  if( !file.exists() ){
	 return;
  }
 qDebug( nameFile_.toLatin1() );
 if (!file.open(QIODevice::ReadOnly | QIODevice::Text) )
		return;	 
	 
  QTextStream in(&file);
  while ( !in.atEnd() ) {
         QString line = in.readLine();
			QTextStream in2 ( &line );
			float x; float y; QPointF point;
		  QString tmp; in2>>tmp;
		  int i;
		  in2 >> i;
		  in2>>x; in2>>y; point.setX( x ) ; point.setY( y ); position[ i ] = point;
		  in2 >>x; in2 >>y; point.setX( x ); point.setY( y ); lineDepart[ i ] = point;
		  in2>>x; in2>>y; point.setX( x ); point.setY( y ); controler[ i ] = point;
		  in2 >>x; in2 >>y; point.setX( x ); point.setY( y ); lineFin[ i ] = point;
		  buildTrace( i );
		  if( position[i].x() != 0 ) {}
  }
  
/*	std::string nameFile = RadialMenu::MENU_PATH + nameFile_;
	
	ifstream file( nameFile.c_str() );
	string line;
	while( ! file.eof() ) {
		
		getline( file, line );
		std::stringstream in( line );
		float x; float y; QPointF point;
		string tmp; in>>tmp;
		int i;
		in >> i;
		in>>x; in>>y; point.setX( x ) ; point.setY( y ); position[ i ] = point;
		in >>x; in >>y; point.setX( x ); point.setY( y ); lineDepart[ i ] = point;
		in>>x; in>>y; point.setX( x ); point.setY( y ); controler[ i ] = point;
		in >>x; in >>y; point.setX( x ); point.setY( y ); lineFin[ i ] = point;
		
		if( position[i].x() != 0 ) {
		}
	}
	
	file.close();
*/
}

//----------------
void FlowerGroupingSector::buildTrace( float i ){
  //float rc = 10;
  QPoint rc( 10, 0);
  float l0 = 83; float c0 = 63;
  float l1 = 58; float c1 = 63;
  float l2 = 43; float c2 = 63;
  float l3 = 43; float c3 = 63;
  int cx = 500;
  int cy = 500;
 
  if( i< 8 ){
	 if( i == 2 ){ l0 = 127; }
	 else if ( i == 6 ) { l0 = 97; }
  
	 float alpha = - 2. * i * 3.14 / 8.;	 
	 QPoint p0( cx + (float)rc.x() * cos( alpha ) - (float)rc.y() * sin( alpha ),
				   cy + (float)rc.x() * sin( alpha ) + (float)rc.y() * cos( alpha ) );
    lineDepart[ i ] = p0;
	 
	 QPoint p1( cx + c0 * cos( alpha ) - 0 * sin( alpha ),
				   cy + c0 * sin( alpha ) + 0 * cos( alpha ) );
	 controler[ i ] = p1;
	 
	 QPoint p2( cx + l0 * cos( alpha ) - 0 * sin( alpha ),
				   cy + l0 * sin( alpha ) + 0 * cos( alpha ) );
	 lineFin[ i ] = p2;
	 
  }else if ( i>=8 && i < 16 ){
	 
  
	  float alpha = - 2. * (i-8.) * 3.14 / 8.;
	  QPoint p0( cx + (float)rc.x() * cos( alpha ) - (float)rc.y() * sin( alpha ),
				    cy + (float)rc.x() * sin( alpha ) + (float)rc.y() * cos( alpha ) );
	  lineDepart[ i ] = p0;
	  
	  QPoint p1( 73, 4 );
	  if( i == 10 ){ p1.setX( 107 ); }
	  else if ( i == 14 ) { p1.setX( 88 ); }
	  if( i== 9 ) { p1.setX( 83); }
  
	  
	  QPoint p1Bis( cx + (float)( p1.x() ) * cos(alpha) - (float)(  p1.y() ) * sin(alpha),
						 cy + (float)( p1.x() ) * sin(alpha) + (float)(  p1.y() ) * cos(alpha) );
	  controler[ i ] = p1Bis;
	  
	  QPoint p2( 68, -25 );
	  if( i == 10 ){ p2.setX( 105 ); }
	  else if ( i == 14 ) { p2.setX( 83 ); }
	  if( i== 9 ) { p2.setX( 78); }
	  
	  QPoint p2Bis( cx + (float)p2.x() * cos(alpha) - (float)(  p2.y() ) * sin(alpha),
						 cy + (float)p2.x() * sin(alpha) + (float)(  p2.y() ) * cos(alpha) ); 
	  lineFin[ i ] = p2Bis;
	  
  }else if ( i>=16 && i < 24 ){
	  float alpha = - 2. * (i-16.) * 3.14 / 8.;
	  QPoint p0( cx + (float)rc.x() * cos( alpha ) - (float)rc.y() * sin( alpha ),
				    cy + (float)rc.x() * sin( alpha ) + (float)rc.y() * cos( alpha ) );
	  lineDepart[ i ] = p0;
	  
	  QPoint p1( 73, -4 );
	  if( i == 18 ){ p1.setX( 107 ); }
	  else if ( i == 22 ) { p1.setX( 88 ); }
     if( i== 17 ) { p1.setX( 88); }
	  
	  QPoint p1Bis( cx + (float)( p1.x() ) * cos(alpha) - (float)(  p1.y() ) * sin(alpha),
						 cy + (float)( p1.x() ) * sin(alpha) + (float)(  p1.y() ) * cos(alpha) );
	  controler[ i ] = p1Bis;
	  
	  QPoint p2( 68, 25 );
	  if( i == 18 ){ p2.setX( 105 ); }
	  else if ( i == 22 ) { p2.setX( 83 ); }
     if( i== 17 ) { p2.setX( 83); }
	  
	  
	  QPoint p2Bis( cx + (float)p2.x() * cos(alpha) - (float)(  p2.y() ) * sin(alpha),
						 cy + (float)p2.x() * sin(alpha) + (float)(  p2.y() ) * cos(alpha) ); 
	  lineFin[ i ] = p2Bis;
	  
  }
  
  
}

//=================
void FlowerGroupingSector::initialize(){
	move(0,0);
	resize(1000,1000);
	
	
	if(first){
		first = false;
		//initPositions( 500, 500);
		for(unsigned int i = 0; i < 800; i ++ ){
			QPointF tmp( 0, 0);
			position.push_back( tmp );
			lineDepart.push_back(tmp);
			controler.push_back( tmp );
			lineFin.push_back(tmp);
		}
		//writePositionFile();
		
		loadPositionFile();
	}
	
	//mainWidget->setFont(QFont("Helvetica", 10));
	//==========================
	
	mainWidget->setAutoFillBackground(true);
	QPalette p(mainWidget->palette());
	p.setColor(mainWidget->backgroundRole(), QColor(255,255,255));
	mainWidget->setPalette(p);
	mainWidget->setFont(QFont("Helvetica", 12));
	
	if( id > position.size() -1 ) {
		cerr<< "id error "<< id <<endl;	
	}
	
	int X = (int)position[ id ].x() ;
	int Y = (int)position[ id ].y() ;
	
	mainWidget->move(X, Y);
	//==========================
	
}

//=================
FlowerGroupingSector::~FlowerGroupingSector(){}

//==================
void FlowerGroupingSector::paintEvent(QPaintEvent* e){
	FlowerGroupingMenu* menu = qobject_cast<FlowerGroupingMenu *>(parent());
	QPainter p(this);
	p.setRenderHint( QPainter::Antialiasing );
	QPen pen(Qt::SolidLine);
	
	
	//pen.setStyle( Qt::DashDotLine );
	pen.setWidth( 1 );
	pen.setColor(Qt::black);
	p.setPen(pen);
	//p.setBrush(Qt::white);
	QWidget* fwm = (QWidget *)parent();
	
	QPoint c( fwm->width()/2, fwm->height()/2);
	QPoint decal;
	
	float centerDist = menu->getCenterDist();
	p.drawEllipse((int) (c.x() - menu->getCenterDist()),
			(int) (c.y() - menu->getCenterDist()),
			(int) (2. * menu->getCenterDist()),
			(int) (2. * menu->getCenterDist()) );
	
	pen.setWidth( 1 );
	QPainterPath myPath( lineDepart[ id ] );
	
	QPointF pWidget(mainWidget->x() + itemWidth() /2, mainWidget->y() + itemHeight()/2);
	
	//myPath.quadTo(controler[id -1], position[id -1] );
	myPath.quadTo(controler[ id ] , lineFin[ id ] );
	p.strokePath(myPath, pen);
	/*
	p.drawLine( lineDepart[ id ], controler [ id ]);
	p.drawLine ( controler[ id ] , lineFin[ id ] );
	*/
	
	if( menu->drawController ){
		
		p.drawEllipse((int) ( lineDepart[ id ].x() - 3 ),
				(int) ( lineDepart[ id ].y() - 3 ), 6, 6 );
		
		p.drawEllipse((int) ( controler[ id ].x() - 3 ),
				(int) ( controler[ id ].y() - 3 ), 6, 6 );
		
		p.drawEllipse((int) ( lineFin[ id ].x() - 3 ),
				(int) ( lineFin[ id ].y() - 3 ), 6, 6 );
		
	}
	
	
}

//=================
void FlowerGroupingSector::initPositions(int w, int h){
	
}


//======================
void FlowerGroupingSector::getDecalage(int id, int& decalX, int& decalY, int w, int h){
	
}
