/********************************************************************************************************
		* PROGRAM      : menus
		* DATE - TIME  : samedi 28 avril 2007 - 12h52
		* AUTHOR       : gilles bailly ( gilles.bailly enst.fr )
			* FILENAME     : FlowerGroupingStateMachine.h
			* LICENSE      : GPL
			* COMMENTARY   :
********************************************************************************************************/
//FlowerGroupingStateMachine.h

#ifndef __FLOWERGrouping_STATE_MACHINE__
#define __FLOWERGrouping_STATE_MACHINE__

#include<QWidget>
#include "StateMachine.h"

class FlowerGroupingMenu;
class FlowerGroupingSector;

//=====================
class FlowerGroupingStateMachine :public StateMachine{
public:
	FlowerGroupingStateMachine(FlowerGroupingMenu* _pflowerGroupingMenu);
	virtual ~FlowerGroupingStateMachine(){}
	
	virtual bool mPress( QObject *obj, QMouseEvent *event ) =0;
	virtual bool mRelease( QObject *obj, QMouseEvent *event )=0;
	virtual bool mDrag( QObject *obj, QMouseEvent *event )=0;
	virtual bool kPress( QObject *obj, QKeyEvent * event);
	virtual bool kRelease( QObject * obj, QKeyEvent * event);
	
	FlowerGroupingMenu* menu;
};

//=====================
class FlowerGroupingStateClosed: public FlowerGroupingStateMachine{
public:
	FlowerGroupingStateClosed(FlowerGroupingMenu* _flowerGroupingMenu);
	virtual ~FlowerGroupingStateClosed(){}
	virtual bool mPress( QObject *obj, QMouseEvent *event );
	virtual bool mRelease( QObject *obj, QMouseEvent *event );
	virtual bool mDrag( QObject *obj, QMouseEvent *event );
};


//=====================
class FlowerGroupingStateBegin: public FlowerGroupingStateMachine{
public:
	FlowerGroupingStateBegin(FlowerGroupingMenu* _flowerGroupingMenu);
	virtual ~FlowerGroupingStateBegin(){}
	virtual bool mPress( QObject *obj, QMouseEvent *event );
	virtual bool mRelease( QObject *obj, QMouseEvent *event );
	virtual bool mDrag( QObject *obj, QMouseEvent *event );
};



//====================
class FlowerGroupingStateTracing : public FlowerGroupingStateMachine{
public:
	FlowerGroupingStateTracing(FlowerGroupingMenu* _flowerGroupingMenu);
	virtual ~FlowerGroupingStateTracing(){}
	virtual bool mPress( QObject *obj, QMouseEvent *event );
	virtual bool mRelease( QObject *obj, QMouseEvent *event );
	virtual bool mDrag( QObject *obj, QMouseEvent *event );
};


//=====================
class FlowerGroupingStateConfiguration: public FlowerGroupingStateMachine{
public:
	FlowerGroupingStateConfiguration(FlowerGroupingMenu* _flowerGroupingMenu);
	virtual bool mPress( QObject *obj, QMouseEvent *event );
	virtual bool mRelease( QObject *obj, QMouseEvent *event );
	virtual bool mDrag( QObject *obj, QMouseEvent *event );
private:
	float xDep;
	float yDep;
	float xCur;
	float yCur;
	float xDiff;
	float yDiff;
	FlowerGroupingSector* sectorCur;
	int type; //-1 vide, 0 item, 1 linedepart, 2 controler, 3 linefin
};

#endif

